
class GaussJordan{

	public double[] solve(double[][] a) {

		int n=a.length;
		int m=a[0].length;

		for(int i=0;i<n;i++) {
			double inv=1.0/a[i][i];
			for(int k=i;k<m;k++) {
				a[i][k]*=inv;
			}

			for(int j=0;j<n;j++) {
				if(i==j)continue;
				double alpha=a[j][i];
				for(int k=i;k<m;k++) {
					a[j][k]-=alpha*a[i][k];
				}
			}
		}

		double[] x=new double[n];
		for(int i=0;i<n;i++) {
			x[i]=a[i][m-1];
		}

		return x;
	}
}


public class Mat_010 {
	public static void main(String[] args) {
		double[][] a= {
				{ 1.0, 1.0, 1.0, 1.0, 10.0},
				{ 2.0, 1.0, 3.0, 2.0, 21.0},
				{ 1.0, 3.0, 2.0, 1.0, 17.0},
				{ 3.0, 2.0, 1.0, 1.0, 14.0}
		};

		double[] x;
		int n=a.length;


		for(int i=0;i<n;i++) {
			for(int j=0;j<n-1;j++) {
				System.out.format("%5.1f*x[%2d] + ",a[i][j],j);
			}
			System.out.format("%5.1f*x[%2d] = ",a[i][n-1],n-1);
			System.out.format("%5.1f\n",a[i][n]);
		}
		System.out.println();

		GaussJordan gj=new GaussJordan();

		x=gj.solve(a);

		System.out.println("answer:");
		for(int i=0;i<n;i++){
			System.out.format("x[%2d]=%5.1f\n",i,x[i]);
		}

	}
}
